<?php
class ControllerModuleGhasedakApi extends Controller
{
    public function onCheckout($order_id)
    {
        $this->load->model('checkout/order');
        $this->load->model('setting/setting');
        $this->load->model('module/ghasedakapi');

        if (version_compare(VERSION, '2.2.0.0', ">=")) {
            if (isset($this->session->data['order_id'])) {
                $order_id = $this->session->data['order_id'];
            } else {
                $order_id = 0;
            }
        }
        if ($order_id == 0) {
		    $this->log->write('GhasedakApi order_id is Null');
			return;
        }
        $order_info = $this->model_checkout_order->getOrder($order_id);
		
        $ghasedakapi_setting = $this->model_setting_setting->getSetting('GhasedakApi', $order_info['store_id']);
        if (version_compare(VERSION, '2.1.0.0', ">=") && version_compare(VERSION, '2.1.0.2', "<=")) {
            $this->load_library('ghasedakapi');
        } else {
            $this->load->library('ghasedakapi');
        }

        //Send SMS to the customer
        if (isset($ghasedakapi_setting)
		&& isset($ghasedakapi_setting['GhasedakApi'])
		&& ($ghasedakapi_setting['GhasedakApi']['Enabled'] == 'yes')
		&& (!empty($ghasedakapi_setting['GhasedakApi']['APIKey']))
		&& ($ghasedakapi_setting['GhasedakApi']['CustomerPlaceOrder']['Enabled'] == 'yes')) {
            $this->log->write('Send SMS to the customer');
            if (!empty($order_info['telephone'])) {
                $phone = $order_info['telephone'];
            } else {
                $phone = '';
            }
            $language = $this->config->get('config_language_id');
            $original = array(
                "{OrderID}",
                "{SiteName}",
                "{CartTotal}"
            );
            $replace  = array(
                $order_id,
                $this->config->get('config_name'),
                $order_info['total']
            );
            $message  = str_replace($original, $replace, $ghasedakapi_setting['GhasedakApi']['CustomerPlaceOrderText'][$language]);
			$localid="1000".(string)$order_id;
            $this->log->write($message);
            try {
                GhasedakApi::Send($ghasedakapi_setting['GhasedakApi']['APIKey'], $this->model_module_ghasedakapi->formatNumber($phone), $ghasedakapi_setting['GhasedakApi']['Sender'],$message,$localid);
            }
            catch (ApiException $ex) {
                $this->model_module_ghasedakapi->logger($ex->errorMessage());
            }
            catch (HttpException $ex) {
                $this->model_module_ghasedakapi->logger($ex->errorMessage());
            }
        }
        //Send SMS to the admin
        if (isset($ghasedakapi_setting)
		&& isset($ghasedakapi_setting['GhasedakApi'])
		&& ($ghasedakapi_setting['GhasedakApi']['Enabled'] == 'yes')
		&& (!empty($ghasedakapi_setting['GhasedakApi']['APIKey']))
		&& ($ghasedakapi_setting['GhasedakApi']['AdminPlaceOrder']['Enabled'] == 'yes')) {
            if (!empty($order_info['telephone'])) {
                $phone = $order_info['telephone'];
            } else {
                $phone = '';
            }
            $_OrderProductNames = "";
            $this->load->model('account/order');
            $order_products = $this->model_account_order->getOrderProducts($order_id);
            foreach ($order_products as $order_product) {
                $_OrderProductNames = $_OrderProductNames . $order_product["name"] . "\n";
            }

            $language     = $this->config->get('config_language_id');
            $original     = array(
                "{OrderID}",
                "{SiteName}",
                "{CartTotal}",
                "{Telephone}",
                "{ShippingAddress}",
                "{NameProducts}"
            );
            $replace      = array(
                $order_id,
                $this->config->get('config_name'),
                $order_info['total'],
                $order_info['telephone'],
                $order_info['shipping_address_1'],
                $_OrderProductNames
            );
            $message      = str_replace($original, $replace, $ghasedakapi_setting['GhasedakApi']['AdminPlaceOrderText']);
            $adminNumbers = array_map('trim', explode(',', $ghasedakapi_setting['GhasedakApi']['StoreOwnerPhoneNumber']));
			$lid=0;
            foreach ($adminNumbers as $phone) {
                try {
				  	$localid="200".$lid.(string)$order_id;
					$lid=$lid+1;
                    GhasedakApi::Send($ghasedakapi_setting['GhasedakApi']['APIKey'], $this->model_module_ghasedakapi->formatNumber($phone), $ghasedakapi_setting['GhasedakApi']['Sender'], $message,$localid);
                }
                catch (ApiException $ex) {
                    $this->model_module_ghasedakapi->logger($ex->errorMessage());
                }
                catch (HttpException $ex) {
                    $this->model_module_ghasedakapi->logger($ex->errorMessage());
                }
            }
        }
    }


	public function onHistoryChange($order_id)
    {

$this->log->write('GhasedakApi : onHistoryChange...');
$this->log->write('GhasedakApi : $order_id =...'.$order_id);

	    $this->load->model('checkout/order');
	    $this->load->model('setting/setting');
		if (version_compare(VERSION, '2.1.0.0', ">=") && version_compare(VERSION, '2.1.0.2', "<=")) {
            $this->load_library('ghasedakapi');
        } else {
            $this->load->library('ghasedakapi');
        }
        if (version_compare(VERSION, '2.2.0.0', ">=")) {
            $order_id = func_get_arg(2);
        }
$this->log->write('GhasedakApi : $order_id =...'.$order_id);
$this->log->write('<pre> GhasedakApi : func_get_arg =...'.print_r(func_get_args(),true)."<pre>");

        $order_info = $this->model_checkout_order->getOrder($order_id);
        $ghasedakapi_setting = $this->model_setting_setting->getSetting('GhasedakApi', $order_info['store_id']);

		//Send SMS when the status order is changed
        if (isset($ghasedakapi_setting)
		&& ($ghasedakapi_setting['GhasedakApi']['Enabled'] == 'yes')
		&& ($ghasedakapi_setting['GhasedakApi']['OrderStatusChange']['Enabled'] == 'yes')) {
            $result = $this->db->query("SELECT count(*) as counter FROM " . DB_PREFIX . "order_history WHERE order_id = " . $order_id);
            if ($order_info['order_status_id'] && $result->row['counter'] > 1
			&& (!empty($ghasedakapi_setting['GhasedakApi']['OrderStatusChange']['OrderStatus'])
			&& (in_array($order_info['order_status_id'], $ghasedakapi_setting['GhasedakApi']['OrderStatusChange']['OrderStatus'])))) {

			$this->log->write("Send SMS when the status order is changed");

                if (isset($order_info['order_status']))
                    $Status = $order_info['order_status'];
                else
                    $Status = "";
                $language = $order_info['language_id'];
                $original = array(
                    "{SiteName}",
                    "{OrderID}",
                    "{Status}"
                );
                $replace  = array(
                    $this->config->get('config_name'),
                    $order_id,
                    $Status
                );
                $message = str_replace($original, $replace, $ghasedakapi_setting['GhasedakApi']['OrderStatusChangeText'][$language]);
                $phone   = $order_info['telephone'];
                try {
                    GhasedakApi::Send($ghasedakapi_setting['GhasedakApi']['APIKey'], $phone, $ghasedakapi_setting['GhasedakApi']['Sender'], $message);
                }
                catch (ApiException $ex) {
                    $this->log->write($ex->errorMessage());
                }
                catch (HttpException $ex) {
                    $this->log->write($ex->errorMessage());
                }
            }
        }
    }

    public function onRegister($customer_id, $data = 0)
    {
        $this->log->write("Ghasedak: onRegister");

        if (!is_numeric($customer_id) && $data != 0) {
            $customer_id = $data;
        }

        $this->load->model('setting/setting');
        $ghasedakapi_setting = $this->model_setting_setting->getSetting('GhasedakApi', $this->config->get('store_id'));
        if (version_compare(VERSION, '2.1.0.0', ">=") && version_compare(VERSION, '2.1.0.2', "<=")) {
            $this->load_library('ghasedakapi');
        } else {
            $this->load->library('ghasedakapi');
        }
        $customer = $this->db->query("SELECT firstname,lastname,telephone FROM `" . DB_PREFIX . "customer` WHERE customer_id = " . (int) $customer_id);
        if ($customer->row) {
            $phone        = $customer->row['telephone'];
            $nameCustomer = $customer->row['firstname'] . " " . $customer->row['lastname'];
        } else {
            $phone        = '';
            $nameCustomer = '';
        }
		//Send SMS to the admin when new user is registered
        if (isset($ghasedakapi_setting)
		&& isset($ghasedakapi_setting['GhasedakApi'])
		&& ($ghasedakapi_setting['GhasedakApi']['Enabled'] == 'yes')
		&& (!empty($ghasedakapi_setting['GhasedakApi']['APIKey']))
		&& ($ghasedakapi_setting['GhasedakApi']['AdminRegister']['Enabled'] == 'yes')) {
            $original = array(
                "{SiteName}",
                "{CustomerName}"
            );
            $replace  = array(
                $this->config->get('config_name'),
                $nameCustomer
            );
            $message  = str_replace($original, $replace, $ghasedakapi_setting['GhasedakApi']['AdminRegisterText']);
            $phone    = $ghasedakapi_setting['GhasedakApi']['StoreOwnerPhoneNumber'];
            try {
                GhasedakApi::Send($ghasedakapi_setting['GhasedakApi']['APIKey'], $phone, $ghasedakapi_setting['GhasedakApi']['Sender'], $message);
            }
            catch (ApiException $ex) {
                $this->log->write($ex->errorMessage());
            }
            catch (HttpException $ex) {
                $this->log->write($ex->errorMessage());
            }
        }
        //Send SMS to the user when the registration is successful
        if (isset($ghasedakapi_setting) && isset($ghasedakapi_setting['GhasedakApi'])
		&& ($ghasedakapi_setting['GhasedakApi']['Enabled'] == 'yes')
		&& (!empty($ghasedakapi_setting['GhasedakApi']['APIKey']))
		&& ($ghasedakapi_setting['GhasedakApi']['CustomerRegister']['Enabled'] == 'yes')) {
            $language = $this->config->get('config_language_id');
            $original = array(
                "{StoreName}",
                "{CustomerName}"
            );
            $replace  = array(
                $this->config->get('config_name'),
                $nameCustomer
            );
            $message = str_replace($original, $replace, $ghasedakapi_setting['GhasedakApi']['CustomerRegisterText'][$language]);
            try {
                GhasedakApi::Send($ghasedakapi_setting['GhasedakApi']['APIKey'], $phone, $ghasedakapi_setting['GhasedakApi']['Sender'], $message);
            }
            catch (ApiException $ex) {
                $this->log->write($ex->errorMessage());
            }
            catch (HttpException $ex) {
                $this->log->write($ex->errorMessage());
            }
        }
    }

    public function load_library($route)
    {
        $route = preg_replace('/[^a-zA-Z0-9_\/]/', '', (string) $route);
        $file  = DIR_SYSTEM . 'library/' . $route . '.php';
        $class = str_replace('/', '\\', $route);
        if (is_file($file)) {
            include_once($file);
            $this->registry->set(basename($route), new $class($this->registry));
        } else {
            throw new \Exception('Error: Could not load library ' . $route . '!');
        }
    }



}
